;===================================================================
MACRO OBJVALLOCINFO [keyname,defval,displayname,valuetype,callbackaddr] {
;===================================================================
; This macro helps build a table that can be processed by the value
; locator and formatter. Every entry requires a corresponding
; OBJVALINDIRECTS use/entry somewhere.

   common
    local tablestart,tableend
				dd   ((tableend-tablestart)/sizeof.ObjValLocatorInfo)
      tablestart:

   forward
    local keynamestraddr,displaynamestraddr
       keyname#_LOCINFO 	ObjValLocatorInfo	keynamestraddr,defval,defval,0,0,displaynamestraddr,\
							keyname#_VALINDIRECTSTABLE,valuetype,callbackaddr
   common
      tableend:

   forward
       keynamestraddr		dstr	`keyname

    if ~ displayname eqtype 0
       displaynamestraddr	dstr	displayname
    else
       displaynamestraddr	=	0
    end if
}


;===================================================================
MACRO OBJVALINDIRECTS keyname,[offsets] {
;===================================================================
   common

    local beginoffsets,endoffsets
      keyname#_VALINDIRECTSTABLE:
				dd	((endoffsets-beginoffsets)/4)
      beginoffsets:

; if ~ offsets eqtype
   forward
		dd	offsets
   common
; end if

      endoffsets:
}
