;============================================================
macro PLUGINSCBINVOKE procoffset,[arg] {
;============================================================
; plugins callback invoke with parameters
; -> is based on the ccall FASM macro

	common

      local .noplugins

	 cmp [pluginqueue.nodecount],0
	     jz .noplugins

	 size@ccall = 4 		; min parameters = 1 (number of parameters)
	 num@ccall = 0

	 if ~ arg eq

	reverse

	 pushd arg
	 size@ccall = size@ccall+4
	 num@ccall = num@ccall+1

	common

	 end if

	 push num@ccall 		; push number of parameters
	 mov ecx,procoffset
	 call InvokeCallbackForAllPlugins

	 if size@ccall
	 add esp,size@ccall		; clean up stack
	 end if

	.noplugins:

      }

;============================================================
macro PLUGINCBSETASACTIVE procoffset {
;============================================================

	if (PLUGIN_DEBUG_MODE = TRUE)
	  mov [pluginactivecallbacks+procoffset],TRUE
	end if

      }

;============================================================
macro PLUGINCBSETASINACTIVE procoffset {
;============================================================

	if (PLUGIN_DEBUG_MODE = TRUE)
	  mov [pluginactivecallbacks+procoffset],FALSE
	end if

      }

;============================================================
macro PLUGINATINITCBINVOKE [arg] {
;============================================================
; returns pointer to new instance in eax or NULL

; args cannot be esi, eax, ecx, edx, or esp-based
; (can be ebp or edi-based)

      common

	local .callbackloop,.notexportedbyplugin,.exitcbinvoke,.instancefound

	push esi

	cmp [pluginqueue.nodecount],0
	    jz .exitcbinvoke

	PLUGINCBSETASACTIVE PLUGIN_CALLBACKS.NewATInit

	mov esi,[pluginqueue.oldestnode]

	.callbackloop:

	mov eax,[esi+sizeof.STDQUEUENODE+PLUGIN_DESC.Callbacks+PLUGIN_CALLBACKS.NewATInit]
	test eax,eax
	     jz .notexportedbyplugin

		stdcall eax,arg 			; stdcall callback
		test eax,eax
		     jnz .instancefound

	.notexportedbyplugin:

	mov esi,[esi+STDQUEUENODE.newernode]
	test esi,esi
	     jnz .callbackloop

	PLUGINCBSETASINACTIVE PLUGIN_CALLBACKS.NewATInit

	.exitcbinvoke:
	xor eax,eax

	.instancefound:
	pop esi
      }


