;============================================================
ATXPROC DisableInGameMvtKeys
;============================================================
push edx
push eax

	mov edx,[KEY_LIST_ADDR]
	xor eax,eax
	mov [edx+4+(5*8)],eax		; jump
	mov [edx+4+(10*8)],eax		; run
	mov [edx+4+(11*8)],eax		; walk
	mov [edx+4+(12*8)],eax		; backward
	mov [edx+4+(13*8)],eax		; left
	mov [edx+4+(14*8)],eax		; right

pop eax
pop edx
ret

;============================================================
ATXPROC DisableInGameKeys		; includes mouse clicks
;============================================================
push eax
push edx
push esi

	mov edx,[KEY_LIST_ADDR]
	lea esi,[edx+15*8]
	add edx,4
	xor eax,eax

	.disableloop:
	mov [edx],eax
	add edx,8
	cmp edx,esi
	jb .disableloop

pop esi
pop edx
pop eax
ret

;============================================================
ATXPROC EnableInGameKeys		; includes mouse clicks
;============================================================
push eax
push edx
push esi

	mov edx,[KEY_LIST_ADDR]
	mov esi,DEFAULT_KEY_BOOLS_TABLE
	add edx,4

	.enableloop:
	mov eax,[esi]
	mov [edx],eax
	add edx,8
	add esi,4
	cmp esi,DEFAULT_KEY_BOOLS_TABLE_END
	jb .enableloop

pop esi
pop edx
pop eax
ret
