;=====================================================
ATXPROC DoTHIRDPAIMCheatRTMain		; THIRDP[ERSON] AIM CHEAT RT CODE
;=====================================================

	cmp [THIRDPAIMAimdotLastObj],0
	    jz .exit

	mov ebp,stack_ext_buffer

	lea ecx,[THIRDPAIMAimdotLastX]
	lea edx,[THIRDPAIM_FinalXValueInt]
	call Convert3DPixelTo2DRender
	test eax,eax
	     jz .exit

	GETCCAMERAINSTANCE eax
	lea esi,[eax+30h]

     ; get vector between dot and camera as well and thus distance between dot and camera
     ; to adjust final gun dot size

	fld [THIRDPAIMAimdotLastX]
	fsub DWORD [esi+00h]
	fmul st0,st0
	fld [THIRDPAIMAimdotLastY]
	fsub DWORD [esi+04h]
	fmul st0,st0
	fld [THIRDPAIMAimdotLastZ]
	fsub DWORD [esi+08h]
	fmul st0,st0
	faddp st1,st0
	faddp st1,st0
	fsqrt							; square root required for proportionality
	fdivr [float_one]					; get reciprocal (inversely proportional)

	fmul [THIRDPAIMAimdotSizeMulCamera]			; distance multiplier
	fistp [THIRDPAIM_FinalDotSize]

	mov esi,[THIRDPAIM_FinalXValueInt]
	mov ebx,[THIRDPAIM_FinalYValueInt]

	GETDDSURFACEDC

     ; load bitmap

	invoke LoadBitmap,[dllhandle],101
	mov [THIRDPAIM_AIMDOTbmpHandle],eax

	invoke CreateCompatibleDC,edi				; DDsurface DC
	mov [THIRDPAIM_CompatibleDCHandle],eax

	invoke SelectObject,eax,[THIRDPAIM_AIMDOTbmpHandle]

     ; set stretching mode (don't know if both are necessary. whatever.)

	invoke SetStretchBltMode,edi,COLORONCOLOR
	invoke SetStretchBltMode,[THIRDPAIM_CompatibleDCHandle],COLORONCOLOR

	mov ecx,[THIRDPAIM_FinalDotSize]
	cmp ecx,THIRDP_MAXIMUM_AIMDOT_SIZE			; max dot size, in pixels
	    jbe @f
	    mov ecx,THIRDP_MAXIMUM_AIMDOT_SIZE
	@@:

	cmp ecx,THIRDP_MINIMUM_AIMDOT_SIZE
	    jnb @f
	    mov ecx,THIRDP_MINIMUM_AIMDOT_SIZE
	@@:

	mov edx,ecx
	shr edx,1						; get half of size
	sub ebx,edx
	sub esi,edx

     ; draw aimdot to screen

	invoke StretchBlt,edi,esi,ebx,ecx,ecx,[THIRDPAIM_CompatibleDCHandle],0,0,\
	       THIRDP_ORIGINAL_AIMDOT_SIZE,THIRDP_ORIGINAL_AIMDOT_SIZE,SRCPAINT

     ; unload bitmap

	invoke DeleteDC,[THIRDPAIM_CompatibleDCHandle]		; delete compatible DC
	invoke DeleteObject,[THIRDPAIM_AIMDOTbmpHandle]

	RELEASEDDSURFACEDC

.exit:
ret