;=====================================================
ATXPROC DisplayLINSTData
;=====================================================
; DISPLAYS LINST CHEAT DATA - INCOMPLETE

push ebp

	GETDDSURFACEDC
	mov ebx,stack_ext_buffer

; print instance count

	cinvoke wsprintf,ebx,LINST_instcount_STR,[LINSTInstanceCount]
	invoke TextOut,edi,0,LINST_DISPLAY_MSG,ebx,eax

; check for 0 instances case

	cmp [LINSTInstanceCount],0
	    jz EXITKEYHANDLER_PASSIVE

	mov ebp,[LINSTCurrentNode]
	test ebp,ebp
	     jz .noinstances

; print instance's string ID from chain object

	cinvoke wsprintf,ebx,LINST_instID_STR,DWORD [ebp+TRES_TREE_NODE.InstanceID]
	invoke TextOut,edi,0,LINST_DISPLAY_MSG+10h,ebx,eax

; print instance's base address

	cinvoke wsprintf,ebx,LINST_instaddr_STR,DWORD [ebp+TRES_TREE_NODE.InstanceAddress]
	invoke TextOut,edi,0,LINST_DISPLAY_MSG+20h,ebx,eax

; print instance's VTable address

	mov eax,[ebp+TRES_TREE_NODE.InstanceAddress]
	cinvoke wsprintf,ebx,LINST_instvtable_STR,DWORD [eax]
	invoke TextOut,edi,0,LINST_DISPLAY_MSG+30h,ebx,eax

; print instance's VTable type (formatted)

	mov eax,[ebp+TRES_TREE_NODE.InstanceAddress]
	mov edx,[eax]					; VTable address
	mov ecx,[edx-4] 				; debug info member (precedes VTable)
	mov eax,[ecx+0Ch]				; sub- debug info member
	add eax,(8+4)					; ".?AV" string start at +8, but skips first characters for clarity

	lea edx,[ebx+300]

; move string, and cut string off at "@@" characters or at null-terminator

	.vtabletypeloop:
	mov cl,[eax]
	cmp WORD [eax],'@@'
	mov [edx],cl
	    jz .vtabletypeloopend
	cmp BYTE [eax],0
	    jz .vtabletypeloopend
	inc eax
	inc edx
	jmp .vtabletypeloop
	.vtabletypeloopend:

	mov BYTE [edx],0

	lea edx,[ebx+300]
	cinvoke wsprintf,ebx,LINST_insttype_STR,edx
	invoke TextOut,edi,0,LINST_DISPLAY_MSG+40h,ebx,eax

	push LINST_nt_right_STR 			; defaults
	push LINST_nt_left_STR
	push LINST_nt_std_STR

	cmp ebp,[LINSTRootNode]
	    jnz @f
	    mov DWORD [esp],LINST_nt_root_STR
	@@:

	mov eax,[ebp+TRES_TREE_NODE.NextLeftNode]
	cmp [eax+TRES_TREE_NODE.NextLeftNode],0
	    jnz @f
	    mov DWORD [esp+4],LINST_nt_noleft_STR
	@@:

	mov eax,[ebp+TRES_TREE_NODE.NextRightNode]
	cmp [eax+TRES_TREE_NODE.NextLeftNode],0
	    jnz @f
	    mov DWORD [esp+8],LINST_nt_noright_STR
	@@:

	invoke wsprintf,ebx,LINST_nodetype_STR
	add esp,20
	invoke TextOut,edi,0,LINST_DISPLAY_MSG+50h,ebx,eax

; exit procedure

	.noinstances:

	RELEASEDDSURFACEDC

pop ebp
ret

;===============================================================
; Key handling code
;===============================================================

;===============================================================
ATXPROC LINSTCycleLeftKeypressed
;===============================================================

	cmp [LINSTEnabled],FALSE
	    jz EXITKEYHANDLER_PASSIVE
	cmp [LINSTInstanceCount],0
	    jz EXITKEYHANDLER_PASSIVE

	mov eax,[LINSTCurrentNode]
	mov ecx,[eax+TRES_TREE_NODE.NextLeftNode]

	cmp [ecx+TRES_TREE_NODE.NextLeftNode],0 	; if current node as 'no' next node, there will be a next node but its left and right members will be null
	    jz EXITKEYHANDLER_PASSIVE

	mov [LINSTCurrentNode],ecx

jmp EXITKEYHANDLER_PASSIVE

;===============================================================
ATXPROC LINSTCycleRightKeypressed
;===============================================================
	cmp [LINSTEnabled],FALSE
	    jz EXITKEYHANDLER_PASSIVE
	cmp [LINSTInstanceCount],0
	    jz EXITKEYHANDLER_PASSIVE

	mov eax,[LINSTCurrentNode]
	mov ecx,[eax+TRES_TREE_NODE.NextRightNode]

	cmp [ecx+TRES_TREE_NODE.NextLeftNode],0 	; if current node as 'no' next node, there will be a next node but its left and right members will be null
	    jz EXITKEYHANDLER_PASSIVE

	mov [LINSTCurrentNode],ecx

jmp EXITKEYHANDLER_PASSIVE

;===============================================================
ATXPROC LINSTCyclePreviousKeypressed
;===============================================================

	cmp [LINSTEnabled],FALSE
	    jz EXITKEYHANDLER_PASSIVE
	cmp [LINSTInstanceCount],0
	    jz EXITKEYHANDLER_PASSIVE

	mov eax,[LINSTCurrentNode]
	cmp eax,[LINSTRootNode]
	    jz EXITKEYHANDLER_PASSIVE

	mov ecx,[eax+TRES_TREE_NODE.PreviousNode]
	mov [LINSTCurrentNode],ecx

jmp EXITKEYHANDLER_PASSIVE

