;=====================================================
ATXPROC DoTHIRDPCheatRTMain
;=====================================================
; THIRDP[ERSON] CHEAT REAL-TIME CODE

	invoke GetTickCount
	mov esi,eax

	stdcall THIRDPCheatKeyHandler,esi
	stdcall THIRDPCheatCamUpdater,esi

ret

;=====================================================
ATXPROC THIRDPCheatKeyHandler		; [esp+4] = tick count
;=====================================================

	JUMPIFNOTGAMEPLAY .exit

	mov eax,[esp+4]
	mov edx,[THIRDPInputRate]
	sub eax,[THIRDPInputTick]
	cmp eax,edx
	mov [esp-4],eax
	    jb .exit

	fild DWORD [esp-4]
	add [THIRDPInputTick],eax
	fstp [THIRDPInputTime]

	invoke GetAsyncKeyState,[THIRDPKeyForward]
	test eax,80000000h
	     jz .noforward
	     fld [THIRDPDistanceSpeed]
	     fchs
	     fmul [THIRDPInputTime]
	     fadd [THIRDPDistance]
	     fst [THIRDPDistance]
	     fcomp [float_0]
	     fstsw ax
	     test ah,1h
		  jz .noreset
		  mov [THIRDPDistance],0
	     jmp .noreset
	.noforward:

	invoke GetAsyncKeyState,[THIRDPKeyBack]
	test eax,80000000h
	     jz .nobackward
	     fld [THIRDPDistanceSpeed]
	     fmul [THIRDPInputTime]
	     fadd [THIRDPDistance]
	     fstp [THIRDPDistance]
	     jmp .noreset
	.nobackward:

	invoke GetAsyncKeyState,[THIRDPKeyReset]
	test eax,80000000h
	     jz .noreset
	     mov eax,[THIRDPDistanceOrig]
	     mov edx,[THIRDPCamAngleZOrig]
	     mov [THIRDPDistance],eax
	     mov [THIRDPCamAngleZ],edx
	.noreset:

	invoke GetAsyncKeyState,[THIRDPKeyUp]
	test eax,80000000h
	     jz .nocamup
	     fld [THIRDPCamSpeed]
	     fmul [THIRDPInputTime]
	     fsubr [THIRDPCamAngleZ]
	     fst [THIRDPCamAngleZ]
	     fcomp [THIRDP_zanglemin]
	     fstsw ax
	     test ah,1h
		  jz .nocamdown 					; below min angle?
		  mov eax,[THIRDP_zanglemin]
		  mov [THIRDPCamAngleZ],eax
	     jmp .nocamdown
	.nocamup:

	invoke GetAsyncKeyState,[THIRDPKeyDown]
	test eax,80000000h
	     jz .nocamdown
	     fld [THIRDPCamSpeed]
	     fmul [THIRDPInputTime]
	     fadd [THIRDPCamAngleZ]
	     fst [THIRDPCamAngleZ]
	     fcomp [THIRDP_zanglemax]
	     fstsw ax
	     test ah,41h
		  jnz .nocamdown					; above max angle?
		  mov eax,[THIRDP_zanglemax]
		  mov [THIRDPCamAngleZ],eax
	.nocamdown:

.exit:
ret 4

;=====================================================
ATXPROC THIRDPCheatCamUpdater		; [esp+4] = tick count
;=====================================================
; VERY FAR FROM OPTIMIZED !!!!!!!!!

JUMPIFNOTGAMEWINDOW .exit

push ebp
mov ebp,esp
sub esp,(32+12+16)

	GETCPLAYERPRIVINSTANCE ecx
	fld DWORD [ecx+50h]						; player health
	fcomp [float_0]
	fstsw ax
	test ah,41h
	     jnz THIRDPCheatCamUpdater_PlayerDead

	mov [THIRDPPlayerDead],FALSE

	call IsPlayerHoldingCGun
	test eax,eax
	mov ecx,eax
	     jz .stdplayerfollow

	     cmp [THIRDPKeyAimToggleOn],1
		 jz DoTHIRDPCGunAIM

	     push ecx
	     invoke GetAsyncKeyState,[THIRDPKeyAim]
	     test eax,80000000h
	     pop ecx
		  jz .stdplayerfollow

	     jmp DoTHIRDPCGunAIM

.stdplayerfollow:

	call THIRDPGetSourcePlayerObject
	push TempFlyBuffer3
	lea edx,[ebp-12]
	add ecx,3Ch
	push edx
	call CONVERT_TO_FACING_PROC_010 				; get CPlayerPriv object direction

;------------------------------------
; calculate camera position (vector displacement)
;------------------------------------
   ; find vector magnitude

	lea eax,[ebp-12]						; facing
	fld DWORD [eax] 						; x facing
	fmul st0,st0
	fld DWORD [eax+4]						; y facing
	fmul st0,st0
	faddp st1,st0
	fsqrt

   ; cosine should be equal to vector magnitude for correct vector; must adjust sine accordingly:
   ; sin/goodsin = cos/magnitude    where magnitude is "goodcos"
   ; -> goodsin = (sin*magnitude)/cos = magnitude*tan (angle is limited to 85 degrees)

	fld [THIRDPCamAngleZ]
	fptan

	fstp st0
	fmulp st1,st0
	fstp DWORD [eax+8]						; camera Z Vector component
	call VectorNormalize						; normalize new vector (eax unchanged

	call THIRDPGetSourcePlayerObject
	fld DWORD [eax] 						; x vector
	add ecx,30h							; source position
	fmul [THIRDPDistance]
	fsubr DWORD [ecx]
	fstp DWORD [ebp-(32+12)]

	fld DWORD [eax+4]						; y vector
	fmul [THIRDPDistance]
	fsubr DWORD [ecx+4]
	fstp DWORD [ebp-(32+12)+4]

	fld DWORD [eax+8]						; z vector
	fmul [THIRDPDistance]
	fsubr DWORD [ecx+8]
	fadd [THIRDPCamDispZ]
	fstp DWORD [ebp-(32+12)+8]

;------------------------------------
; orient camera (quats & angles)
;------------------------------------

	lea edx,[ebp-(32+12+16)]
	mov ecx,THIRDPCamAngleZ
	call ToLocalQuat_AxisX_NoNorm

	call THIRDPGetSourcePlayerObject
	lea eax,[ecx+3Ch]						; source quat 2 (object)
	lea ecx,[ebp-(32+12+16)]					; source quat 1
	lea edx,[ebp-(32+12)+12]					; destination
	call QuaternionMulLocalQ2AxisX

   ; (could normalize quat here, doesn't seem necessary)

;------------------------------------
; update camera position
;------------------------------------

       lea edx,[ebp-(32+12)]
       call CCameraTeleport

mov esp,ebp
pop ebp
.exit:
ret 4

;------------------------------------
THIRDPGetSourcePlayerObject = GetCPlayerPrivInstance			; returns in ecx
;------------------------------------

	;call GetCPlayerPrivInstance
	;cmp [THIRDPUseBaseObject],0   ;use CPlayerPriv or head object for source?
	;    jnz THIRDPGetSourcePlayerObjectEXIT
	;    mov ecx,[ecx+0ACh]
	;    mov ecx,[ecx+024h]
	;THIRDPGetSourcePlayerObjectEXIT:
	;ret


;=====================================================
ATXPROC DoTHIRDPCGunAIM 	; ecx = CGun object to follow
;=====================================================
; requires pre-set stack frame

push esi
mov esi,ecx

	push TempFlyBuffer3
	lea edx,[ebp-12]
	add ecx,3Ch
	push edx
	call CONVERT_TO_FACING_PROC_010 				; get CGun object direction

; calculate camera position (vector displacement)

	fld DWORD [eax]
	fmul [THIRDPDistance]
	fsubr DWORD [esi+30h]
	fstp DWORD [ebp-(32+12)]

	fld DWORD [eax+4]
	fmul [THIRDPDistance]
	fsubr DWORD [esi+34h]
	fstp DWORD [ebp-(32+12)+4]

	fld DWORD [eax+8]
	fmul [THIRDPDistance]
	fsubr DWORD [esi+38h]
	fstp DWORD [ebp-(32+12)+8]

	mov eax,[esi+3Ch]
	mov ecx,[esi+40h]
	mov [ebp-(32+12)+12],eax
	mov [ebp-(32+12)+16],ecx
	mov eax,[esi+44h]
	mov ecx,[esi+48h]
	mov [ebp-(32+12)+20],eax
	mov [ebp-(32+12)+24],ecx

; update camera position (same orientation as CGun object)

	lea edx,[ebp-(32+12)]
	call CCameraTeleport

pop esi
mov esp,ebp
pop ebp
ret 4

;=====================================================
ATXPROC THIRDPCheatCamUpdater_PlayerDead	; ecx = CPlayerPriv obj
;=====================================================
; requires pre-set stack frame (tick count at DWORD [ebp+8])

	cmp [THIRDPPlayerDead],FALSE
	    jz .init
	mov [THIRDPPlayerDead],TRUE

	mov eax,[ebp+8] 						; current tick count
	sub eax,[THIRDPDeathCamTick]					; time of death
	cmp eax,[THIRDP_deathcamrate]					; minimum difference
	    jb .exit							; player dead long enough to update camera

	mov eax,[ecx+30h]
	mov edx,[ecx+34h]
	mov ecx,[ecx+38h]
	mov [ebp-(32+12)],eax
	mov [ebp-(32+12)+4],edx
	mov [ebp-(32+12)+8],ecx 					; copy player position

	mov DWORD [ebp-(32+12)+12],0.707106781186547524400844362104849	; copy orientation quaternion, 90 degrees around x axis(fixed)
	mov DWORD [ebp-(32+12)+16],-0.707106781186547524400844362104849
	mov DWORD [ebp-(32+12)+20],0
	mov DWORD [ebp-(32+12)+24],0

	fld DWORD [ebp-(32+12)+8]
	fadd [THIRDPDistance]						; add vertical distance
	fstp DWORD [ebp-(32+12)+8]


; update camera position

	lea edx,[ebp-(32+12)]
	call CCameraTeleport

.exit:
mov esp,ebp
pop ebp
ret 4

.init:

	mov eax,[ebp+8] 						; tick count
	mov [THIRDPPlayerDead],TRUE
	mov [THIRDPDeathCamTick],eax

mov esp,ebp
pop ebp
ret 4




