;============================================================
ATXPROC GetCPlayerPrivInstance
;============================================================
; destroyed: ecx only, returns in ecx

	GETCPLAYERPRIVINSTANCE ecx

ret

;============================================================
ATXPROC GetPlayerPrivAIType
;============================================================
; returns in eax

	GETCPLAYERPRIVINSTANCE edx
	mov eax,[edx+0ACh]		; eax=first sub-class leading to AIType
	mov ecx,[eax+28h]		; ecx=2nd...
	xor eax,eax
	mov edx,[ecx+10h]		; edx= AIType sub-class
	mov al,[edx+08]

ret

;============================================================
ATXPROC ChangePlayerPrivAIType
;============================================================
; switches player class AITypes
; BYTE [esp+4] = new AIType (-1 for switch from 0-5/5-0)

push edi
push edx

	GETCPLAYERPRIVINSTANCE edi

	mov eax,[edi+0ACh]		; eax=first sub-class leading to AIType
	mov ecx,[eax+28h]		; ecx=2nd...
	mov edx,[ecx+10h]		; edx= AIType sub-class

	mov al,[esp+12]
	    cmp al,0FFh
		jnz .settonull1
	mov al,[edx+8h] 		; al = AIType value
	    sub al,AITYPE_PLAYER
		jz .settonull1
	    mov al,AITYPE_PLAYER
	    .settonull1:
	mov [edx+8h],al

	mov eax,[edi+0B0h]		; eax=first sub-class leading to AIType2
	mov ecx,[eax+28h]		; ecx=2nd...
	mov edx,[ecx+10h]		; edx= AIType2 sub-class

	mov al,[esp+12]
	    cmp al,0FFh
		jnz .settonull2
	mov al,[edx+8h] 		; al = AIType2 value
	    sub al,AITYPE_PLAYER
		jz .settonull2
	    mov al,AITYPE_PLAYER
	    .settonull2:
	mov [edx+8h],al

; note: there is a third first sub-class, but it points to the same
;       sub-classes as the second first sub-class

pop edx
pop edi
ret 4