;===================================================================
MACRO FINDSTRINGEND reg1 {
;===================================================================
local NoNullTerminator,StringSizeNull
      cmp BYTE [reg1],0
	  jz StringSizeNull
      NoNullTerminator:
      inc reg1
      cmp BYTE [reg1],0
	  jnz NoNullTerminator
      StringSizeNull:
      }

;===================================================================
MACRO CHAR_TOLOWERCASE reg {
;===================================================================
	cmp reg,5Ah
	    ja @f
	cmp reg,41h
	    jb @f
	add reg,20h
	@@:
	}

;===================================================================
MACRO RCALL releaseproc, param1 {
;===================================================================
      cmp param1,0
	  jz @f
      invoke releaseproc,param1
      mov param1,0
      @@:
      }


;===================================================================
MACRO VIRTUALRELEASE buffer1,size1  {
;===================================================================
	cmp buffer1,0
	    jz @f
	    invoke VirtualFree,buffer1,size1,MEM_DECOMMIT
	    invoke VirtualFree,buffer1,0,MEM_RELEASE
	    mov buffer1,0
	@@:
	}

;============================================================
MACRO ZEROMEM { 	 ;ecx = number of bytes, edi = buffer
;===================================================================
      local DoPerByteNullify,NoDoPerByteNullify
      mov edx,ecx
      test ecx,0FFFFFFFCh
	  jz DoPerByteNullify
      xor eax,eax
      shr ecx,2
      rep stosd
      DoPerByteNullify:
      and edx,3
	  jz NoDoPerByteNullify
	  mov ecx,edx
	  rep stosb
      NoDoPerByteNullify:
      }

;===================================================================
MACRO LOCALRELEASE buffer1 {
;===================================================================
;note: In many instances, the line "and buffer1,0" is unnecessary, but will never
;cause problems. As such, it is not fully optimized.

	cmp buffer1,0
	    jz @f
	    invoke LocalFree,buffer1
	    mov buffer1,0
	@@:
	}

;===================================================================
MACRO LOCALRELEASENONULL buffer1 {
;===================================================================
	cmp buffer1,0
	    jz @f
	    invoke LocalFree,buffer1
	@@:
	}