;=======================================================
#label VAllocMemoryWrap()_2 = 0x005DCB10
;=======================================================
VOID VAllocMemoryWrap(
 LPVOID lpAddressToReserve,
 INT NumberOfBytes
);

Uses VirtualAlloc and internal buffers.

;=======================================================
#label VAllocInstanceMemory()_1 = 0x005F5A20
;=======================================================
LPVOID VAllocInstanceMemory(
 INT NumberOfBytes
);

Uses VAllocMemoryWrap(), but allocates mem at a
generated location for instance.

;=======================================================
#label VAllocInstanceMemory2()_1 = 0x00615A00
;=======================================================
LPVOID VAllocInstanceMemory2(
 INT NumberOfBytes
);

Uses VAllocMemoryWrap(). ?

;=======================================================
#label VFreeInstanceMemory()_2 = 0x005DCAE0
;=======================================================
VOID VFreeInstanceMemory(
 LPVOID lpAddress,
 DWORD dwSize
);

Decommits and releases via VirtualFree.

;=======================================================
#label VTranslateFreeInstMemPtr()_2 = 0x005DCB40
;=======================================================
LPVOID VTranslateFreeInstMemPtr(
 LPVOID lpLogicalAddress,
 DWORD dwSize
);

Returns a direct address pointer to the memory
related to the lpLogicalAddress parameter, but may
or may not be decommited (?).

Decommits only, via VirtualFree. Seems to take a
relative address, as is added to other pointers.

;=======================================================
#label FreeMemoryWrap()_1 = 0x00609060
;=======================================================
VOID FreeMemoryWrap(
 LPVOID lpMemoryToFree
);

Calls MSVCRT.free, does nothing else.

;=======================================================
#label AllocMemoryWrap()_1 = 0x006090CC
;=======================================================
VOID FreeMemoryWrap(
 DWORD NumBytes
);

Jumps to MSVCRT.operatornew only, does nothing else.


;=======================================================
#label AllocHandledMemoryWrap()_2 = 0x0049CCB0
;=======================================================
LPVOID AllocHandledMemoryWrap(
 INT NumQWORDSToAlloc,
 DWORD Reserved        // is unused, usually null.
);

Does
return AllocMemoryWrap(8*NumQWORDSToAlloc);

But also sets new handler, sends ostream "out of memory"
if not allocated and calls endl and exit.





