; The following struc macro is used to define strings with an automatic null-terminator
; and size label (form: "[stringlabel].size"). Based on redefinition of 'db' directive
; as described in FASM documentation.

struc dstr [data] {

	common

      if used .

	if (DSTR_STRING_ALIGNMENT > 0)
	  align DSTR_STRING_ALIGNMENT
	end if

	. db data
	.size = $ - .
	db    0

      end if

      }


; This struct is essential for communication with the patched-EXE code
; MUST NOT BE CHANGED!!!

struct ATX_EXIT_INFO
       lpFreeLibrary		dd	?
       ATXModuleHandle		dd	?
       lpExitProc		dd	?	; may be Kernel32.ExitProcess, MSVCRT.exit, or MSVCRT._exit
ends


; high-priority constants

MAX_PATH			equ	260
