;==========================================================
ATXPROC AT109MAIN
;==========================================================
; CParticles default color switcher

push esi
mov esi,ecx

;/* CHECK IF WE ARE MODIFYING ONE OF THE 7 DEFAULT PARTICLE TYPES

	mov edx,[esi+CAT109.ParticleNameID]
	call CParticlesFindTypeIDInTable
	cmp eax,-1
	jz .nonightmodecheck

	mov edx,[esi+CAT109.Color]			; new color
	mov [CPAT109Color+eax],edx			; change color in buffer only so that NIGHT modifications apply

	; call CParticlesColorGlobalUpdate               ; because should only be used during level load (CStartTrigger)
							; this will only be called at ENDLEVELLOAD

pop esi
ret
;*/

.nonightmodecheck:

; this returns a pointer to a CParticles data structure (if existing)
; corresponding the particle type name ID passed as first param

	ccall [CParticlesGetObjProc],[esi+CAT109.ParticleNameID],0

	test eax,eax
	jz .getobjerror

	mov edx,[esi+CAT109.Color]			; new color
	mov [eax+4],edx 				; update color

.getobjerror:
pop esi
ret

;==========================================================
ATXPROC AT109_REINIT
;==========================================================
; APPLY THIS ACTIONTYPE AT ANY LEVEL RESTART OR LOAD

	call AT109MAIN

mov eax,[esp+4]
ret 4

