;==========================================================
ATXPROC AT117MAIN
;==========================================================
; AT117 - Initiate particle effect display

; can use PlayerInTrigger and RepeatPeriod in CLocationTrigger
; to loop AT117

push esi
push edi
mov esi,ecx

    ; get CParticles instance

	ccall [CParticlesGetObjProc],[esi+CAT117.CParticlesNameID],0
	test eax,eax
	jz .exitmain

	mov edi,eax

    ; get placeholder instance

	GETINSTANCEFROMID32 [esi+CAT117.PlaceHolderInstanceID]
	test eax,eax
	jz .exitmain

    ; pass extra params for main particle create proc (last)

	push [esi+CAT117.ThresholdValue]
	push [esi+CAT117.Param7Value]
	sub esp,(6*4)

    ; pass location values (first)

	mov ecx,[eax+CInstance.Location.X]
	mov edx,[eax+CInstance.Location.Y]
	mov [esp],ecx
	mov ecx,[eax+CInstance.Location.Z]
	mov [esp+4],edx
	mov [esp+8],ecx

    ; pass vector direction values (second)

	lea ecx,[eax+CInstance.OrientationQuat]
	lea edx,[esp+12]
	push TempFlyBuffer3
	push edx
	call [PTRCONVERT_TO_FACING_PROC_010]

    ; call main particle effect creation proc

	mov ecx,edi
	call [CParticlesDoEffectProc]

.exitmain:
pop edi
pop esi
ret

