;====================================================================
ATINITPROC _AT120Init
;====================================================================

	ALLOCATBASE sizeof.CAT120,AT120
	mov DWORD [edi+CAT120.UseResetFireCount],ecx


; get Target trigger instance

	SETLASTATERROR AT120_INITABORTMSG_NOTARGET

	GETSETVALUERET TSCRIPT_OFFSETVALUE_A00,0,TSCRIPT_VALUETYPE_STRING
	test eax,eax
	jz NoNewActionTypeFreeMem

	GETNAMEID32STD eax
	test eax,eax
	jz NoNewActionTypeFreeMem

	mov [edi+CAT120.lpTriggerInstanceID],eax


; get fire count value (Sample)

	SETLASTATERROR AT120_INITABORTMSG_NOFIRECOUNT

	GETSETVALUEDIR TSCRIPT_OFFSETVALUE_SAMPLE,1,TSCRIPT_VALUETYPE_INT,CAT120.NewFireCount
	test eax,eax
	jz NoNewActionTypeFreeMem


; get probability value (LoopCount)

       ; SETLASTATERROR AT120_INITABORTMSG_NOPROB

	GETSETVALUERET TSCRIPT_OFFSETVALUE_LOOPCOUNT,2,TSCRIPT_VALUETYPE_INT
	test eax,eax
	jnz @f

		mov eax,AT120_DEFAULT_PROBABILITY

	@@:

   ; /* CODE COPIED FROM GAME EXECUTABLE (exact function )

	mov ecx,eax
	imul ecx,AT120_PROB_BOUNDS_MULT_VALUE		; result in ecx
	cmp eax,AT120_MAX_PROBABILITY
	mov [edi+CAT120.NewProbability],ecx
	jnz @f

		mov [edi+CAT120.NewProbability],AT120_NO_PROBABILITY_VALUE
	@@:

   ; */


; get reset fire bool (Frame)

	GETSETVALUEDIRBYTE TSCRIPT_OFFSETVALUE_FRAME,3,TSCRIPT_VALUETYPE_BOOL,CAT120.UseResetFireCount

	jmp ExitINAT
