;========================================================
; ATXconfig.ini INI file entries
;========================================================
; (does not optimize for space; keeps code simple)

align 16

INI_ENTRIES_TABLE:

ATXCONFIGENTRY	INI_INT_PROC		, section_general		, key_sdbg		, 0				, UseTresStrDbg
ATXCONFIGENTRY	INI_INT_PROC		, section_general		, key_wndo		, 0				, UseWindowedMode
ATXCONFIGENTRY	INI_INT_PROC		, section_general		, key_dems		, 1				, UseDemoAdScreenHack
ATXCONFIGENTRY	INI_INT_PROC		, section_general		, key_rand		, 0				, UseRandomInstanceLocations
ATXCONFIGENTRY	INI_INT_PROC		, section_general		, key_highres		, 1				, UseHighResolutionsHack
ATXCONFIGENTRY	INI_INT_PROC		, section_general		, key_gamediff		, 2				, GameDifficultyValue
ATXCONFIGENTRY	INI_INT_PROC		, section_general		, key_usenewitems	, 1				, UseNewMenuItems
ATXCONFIGENTRY	INI_INT_PROC		, section_general		, key_dinovocal 	, 23				, UseNewDinoVocals
ATXCONFIGENTRY	INI_INT_PROC		, section_general		, key_maxdinos		, 0				, UseMaxActiveDinos
ATXCONFIGENTRY	INI_INT_PROC		, section_general		, key_lbg		, 1				, UseNewBackgroundImages
ATXCONFIGENTRY	INI_INT_PROC		, section_general		, key_disablefastload	, FALSE 			, DisableFastLoad
ATXCONFIGENTRY	INI_INT_PROC		, section_general		, key_atx3dnow		, FALSE 			, UseATX3DNowOpts
ATXCONFIGENTRY	INI_INT_PROC		, section_general		, key_oldvprotect	, FALSE 			, UseOldVirtualProtectFunction
ATXCONFIGENTRY	INI_INT_PROC		, section_general		, key_usehud		, FALSE 			, UseHUD
ATXCONFIGENTRY	INI_INT_PROC		, section_general		, key_textdumper	, TRUE				, UseScreenTextDumper

ATXCONFIGENTRY	INI_FLOAT_PROC		, section_vars			, key_draw		, ZERO_STRING			, UseDrawDistance
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_vars			, key_grav		, ZERO_STRING			, UseGravityVar
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_vars			, key_gspd		, ZERO_STRING			, NormalGameSpeed
ATXCONFIGENTRY	INI_INT_PROC		, section_vars			, key_gpsdnosvgset	, FALSE 			, OverrideSVGSpeed
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_vars			, key_camfov		, ZERO_STRING			, AT06CameraFOVValue

ATXCONFIGENTRY	INI_INT_PROC		, section_fly			, key_flyd		, fly_delay_int 		, UseFlyKeyDelay
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_fly			, key_flys		, fly_speed_str 		, UseFlySpeedOrig

ATXCONFIGENTRY	INI_INT_PROC		, section_mxt			, key_mxtb		, 0				, UseMXTOnActBite
ATXCONFIGENTRY	INI_INT_PROC		, section_mxt			, key_intr		, DefaultInterval_CONST 	, DefaultInterval
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_mxt			, key_slow		, DefaultSlowSpeed_CONST	, DefaultSlowSpeed
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_mxt			, key_mxtr		, DefaultMXTRadius		, UseMXTRadius
ATXCONFIGENTRY	INI_INT_PROC		, section_mxt			, key_mxtenterintr	, DefaultEnterInterval_CONST	, DefaultEnterTransitionInterval
ATXCONFIGENTRY	INI_INT_PROC		, section_mxt			, key_mxtexitintr	, DefaultExitInterval_CONST	, DefaultExitTransitionInterval

ATXCONFIGHOTKEYENTRIES:
ATXCONFIGENTRY	INI_KEY_PROC		, section_hotkeys		, key_ktog		, ZERO_STRING			, UseToggleNewKeys			; (does not include additional cheat-specific and respectively named keys)
ATXCONFIGENTRY	INI_KEY_PROC		, section_hotkeys		, key_kdrs		, ZERO_STRING			, UseDrawDistSubKey
ATXCONFIGENTRY	INI_KEY_PROC		, section_hotkeys		, key_kdra		, ZERO_STRING			, UseDrawDistAddKey
ATXCONFIGENTRY	INI_KEY_PROC		, section_hotkeys		, key_linstleft 	, ZERO_STRING			, LINSTCycleLeftKey
ATXCONFIGENTRY	INI_KEY_PROC		, section_hotkeys		, key_linstright	, ZERO_STRING			, LINSTCycleRightKey
ATXCONFIGENTRY	INI_KEY_PROC		, section_hotkeys		, key_linstprevious	, ZERO_STRING			, LINSTCyclePreviousKey
ATXCONFIGHOTKEYENTRIESEND:

ATXCONFIGENTRY	INI_INT_PROC		, section_ai			, key_ainb		, 0				, UseNoGetOut
ATXCONFIGENTRY	INI_INT_PROC		, section_ai			, key_stnr		, 0				, UseNoStayNear
ATXCONFIGENTRY	INI_INT_PROC		, section_ai			, key_staw		, 0				, UseNoStayAway
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_ai			, key_dpts		, ZERO_STRING			, UseCAnimalHitPoints
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_ai			, key_frez		, ZERO_STRING			, UseSleepWake

ATXCONFIGENTRY	INI_INT_PROC		, section_troubleshooting	, key_noa3d		, 0				, UseDisableA3Ddll
ATXCONFIGENTRY	INI_INT_PROC		, section_troubleshooting	, key_outddrawenum	, 0				, UseOutputDDrawEnum
ATXCONFIGENTRY	INI_STR_EXT_PROC	, section_troubleshooting	, key_forcedmodes	, ZERO_STRING			, ForcedResolutionsListStr
ATXCONFIGENTRY	INI_INT_PROC		, section_troubleshooting	, key_highresmax	, 2048				, HIGHRESCMPREPLACE
ATXCONFIGENTRY	INI_INT_PROC		, section_troubleshooting	, key_dswp		, 0				, UseDisableSWPDelete
ATXCONFIGENTRY	INI_INT_PROC		, section_troubleshooting	, key_menukeysfix	, 1				, UseMenuKeysFix
ATXCONFIGENTRY	INI_INT_PROC		, section_troubleshooting	, key_disablesmkeffects , 0				, SMKEffects_DisableSMKEffects

ATXCONFIGENTRY	INI_INT_PROC		, section_actjumpnew		, key_nojump		, FALSE 			, UseDisableActJumpNew
ATXCONFIGENTRY	INI_INT_PROC		, section_actjumpnew		, key_noquadjump	, FALSE 			, UseDisableQuadrupedJumps
ATXCONFIGENTRY	INI_STR_PROC		, section_actjumpnew		, key_pushdef		, INI_Push_Def			, PushINIdef
ATXCONFIGENTRY	INI_STR_PROC		, section_actjumpnew		, key_jumpadef		, INI_JumpAngle_Def		, JumpAngleINIdef
ATXCONFIGENTRY	INI_INT_PROC		, section_actjumpnew		, key_jumptdef		, INI_JumpTDef			, JumpTendancyINIdef
ATXCONFIGENTRY	INI_INT_PROC		, section_actjumpnew		, key_reppdef		, INI_RepeatPDef		, RepeatPeriodINIdef
ATXCONFIGENTRY	INI_INT_PROC		, section_actjumpnew		, key_tcperioddef	, INI_TCPeriodDef		, TendancyCheckPeriodINIdef
ATXCONFIGENTRY	INI_STR_PROC		, section_actjumpnew		, key_anglebody 	, INI_MaxBodyTargetDirAngle_def , MaxBodyTargetDirAngleINIdef
ATXCONFIGENTRY	INI_STR_PROC		, section_actjumpnew		, key_anglehead 	, INI_MaxHeadTargetDirAngle_def , MaxHeadTargetDirAngleINIdef
ATXCONFIGENTRY	INI_STR_PROC		, section_actjumpnew		, key_minspeed		, INI_MinTotalVelocity_def	, MinTotalVelocityINIdef
ATXCONFIGENTRY	INI_STR_PROC		, section_actjumpnew		, key_mindirspeed	, INI_MinDirectionalVelocity_def, MinDirectionalVelocityINIdef
ATXCONFIGENTRY	INI_STR_PROC		, section_actjumpnew		, key_maxdirangle	, INI_MaxDirVelocityAngle_def	, MaxDirVelocityAngleINIdef
ATXCONFIGENTRY	INI_STR_PROC		, section_actjumpnew		, key_mintargetdist	, INI_MinTargetDistance_def	, MinTargetDistanceINIdef
ATXCONFIGENTRY	INI_STR_PROC		, section_actjumpnew		, key_maxtargetdist	, INI_MaxTargetDistance_def	, MaxTargetDistanceINIdef

ATXCONFIGENTRY	INI_INT_PROC		, section_videorecording	, key_width		, 320				, dibfileheader.BitmapData.biWidth
ATXCONFIGENTRY	INI_INT_PROC		, section_videorecording	, key_height		, 240				, dibfileheader.BitmapData.biHeight
ATXCONFIGENTRY	INI_INT_PROC		, section_videorecording	, key_framerate 	, 20				, dibfileheader.Framerate
ATXCONFIGENTRY	INI_INT_PROC		, section_videorecording	, key_maxframes 	, 2500				, dibfileheader.MaxFrameCount
ATXCONFIGENTRY	INI_INT_PROC		, section_videorecording	, key_savemethod	, SAVE_METHOD_NEW_DX		, NewSaveMethod
ATXCONFIGENTRY	INI_INT_PROC		, section_videorecording	, key_invertatcomp	, FALSE 			, InvertAtComp
ATXCONFIGENTRY	INI_INT_PROC		, section_videorecording	, key_nolowfpscomp	, FALSE 			, NoLowFPSComp
ATXCONFIGENTRY	INI_INT_PROC		, section_videorecording	, key_enableaudio	, 0				, mci_audio_capt_enabled
ATXCONFIGENTRY	INI_INT_PROC		, section_videorecording	, key_bitspersample	, 16				, mci_bitspersample
ATXCONFIGENTRY	INI_INT_PROC		, section_videorecording	, key_channelcount	, 2				, mci_channelcount
ATXCONFIGENTRY	INI_INT_PROC		, section_videorecording	, key_samplespersec	, 22050 			, mci_samplespersec
ATXCONFIGENTRY	INI_INT_PROC		, section_videorecording	, key_bytespersec	, 88200 			, mci_bytespersec
ATXCONFIGENTRY	INI_INT_PROC		, section_videorecording	, key_usewritethrough	, FALSE 			, UseRECWriteThrough

ATXCONFIGENTRY	INI_FLOAT_PROC		, section_followdinocheat	, key_mousesens 	, followdino_mousesens		, FDMouseCtrlMultiplier
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_followdinocheat	, key_inputrate 	, followdino_inputrate		, FDInputInterval			; will be converted to INT
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_followdinocheat	, key_defaultdist	, followdino_defaultdist	, FDDistanceCurrent
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_followdinocheat	, key_distancespeed	, followdino_distancespeed	, FDDistanceSpeed
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_followdinocheat	, key_invertmousemul	, followdino_invertmousemul	, FDInvertMouseMul

ATXCONFIGENTRY	INI_FLOAT_PROC		, section_thirdpersoncheat	, key_tpinputrate	, tp_tpinputrate		, THIRDPInputRate
ATXCONFIGENTRY	INI_KEY_PROC		, section_thirdpersoncheat	, key_tpkeyforward	, STRING_KEY_LOWER_I		, THIRDPKeyForward
ATXCONFIGENTRY	INI_KEY_PROC		, section_thirdpersoncheat	, key_tpkeyback 	, STRING_KEY_LOWER_K		, THIRDPKeyBack
ATXCONFIGENTRY	INI_KEY_PROC		, section_thirdpersoncheat	, key_tpkeyreset	, STRING_KEY_LOWER_U		, THIRDPKeyReset
ATXCONFIGENTRY	INI_KEY_PROC		, section_thirdpersoncheat	, key_tpkeyup		, STRING_KEY_LOWER_O		, THIRDPKeyUp
ATXCONFIGENTRY	INI_KEY_PROC		, section_thirdpersoncheat	, key_tpkeydown 	, STRING_KEY_LOWER_L		, THIRDPKeyDown
ATXCONFIGENTRY	INI_KEY_PROC		, section_thirdpersoncheat	, key_tpkeyaim		, STRING_KEY_LOWER_V		, THIRDPKeyAim
ATXCONFIGENTRY	INI_KEY_PROC		, section_thirdpersoncheat	, key_tptoggleaim	, STRING_KEY_LOWER_B		, THIRDPKeyAimToggle
ATXCONFIGENTRY	INI_KEY_PROC		, section_thirdpersoncheat	, key_tptoggleaimdot	, STRING_KEY_LOWER_N		, THIRDPKeyAimDotToggle
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_thirdpersoncheat	, key_tpdistance	, tp_tpdistance 		, THIRDPDistance
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_thirdpersoncheat	, key_tpdistancespeed	, tp_tpdistancespeed		, THIRDPDistanceSpeed
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_thirdpersoncheat	, key_tpcamspeed	, tp_tpcamspeed 		, THIRDPCamSpeed
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_thirdpersoncheat	, key_tpcamzdisp	, tp_tpcamzdisp 		, THIRDPCamDispZ
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_thirdpersoncheat	, key_tpcamzangledef	, tp_tpcamzangledef		, THIRDPCamAngleZ

ATXCONFIGENTRY	INI_INT_PROC		, section_nightmode		, key_nightenable	, def_nightenable		, NIGHTEnabled
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_nightmode		, key_nightfognear	, def_nightfognear		, NIGHTFogNearCurrent
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_nightmode		, key_nightfogfar	, def_nightfogfar		, NIGHTFogFarCurrent
ATXCONFIGENTRY	INI_HEX_PROC		, section_nightmode		, key_nightfogcolor	, def_nightfogcolor		, NIGHTFogColorCurrent
ATXCONFIGENTRY	INI_HEX_PROC		, section_nightmode		, key_nightcpmax	, def_nightcpmax		, NIGHTCParticlesColorMax
ATXCONFIGENTRY	INI_INT_PROC		, section_nightmode		, key_nightcpdef	, def_nightcpdef		, NIGHTCParticlesTypes
ATXCONFIGENTRY	INI_HEX_PROC		, section_nightmode		, key_nightclutstart	, def_nightclutstart		, NIGHTDefaultGlobalClutStart
ATXCONFIGENTRY	INI_HEX_PROC		, section_nightmode		, key_nightclutstop	, def_nightclutstop		, NIGHTDefaultGlobalClutStop
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_nightmode		, key_ambientlight	, def_nightamblight		, NIGHTAmbientLight
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_nightmode		, key_nightskyheight	, def_nightskyheight		, NIGHTSkyHeight
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_nightmode		, key_nightfogpower	, def_nightfogpower		, NIGHTFogPower
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_nightmode		, key_nightfoghalf	, def_nightfoghalf		, NIGHTFogHalf

ATXCONFIGENTRY	INI_INT_PROC		, section_gamesaving		, key_enableatxqs	, TRUE				, QuickSaveEnabled
ATXCONFIGENTRY	INI_STR_PROC		, section_gamesaving		, key_qscurrentfile	, def_qscurrentfile		, QuickSaveCurrentFileName

ATXCONFIGENTRY	INI_HEX_PROC		, section_fogsettings		, key_deffogcolor	, gen_deffogcolor		, DefaultFogColorValue
ATXCONFIGENTRY	INI_INT_PROC		, section_fogsettings		, key_overfogvalues	, FALSE 			, DisableGameFog
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_fogsettings		, key_fogpowerforced	, ZERO_STRING			, FogSettingsForcedFogPowerValue
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_fogsettings		, key_foghalfforced	, ZERO_STRING			, FogSettingsForcedFogHalfValue


ATXCONFIGENTRY	INI_STR_EXTMAX_PROC	, section_tpafiles		, key_tpamenu		, def_qscurrentfile		, AlternateMenuTPAFileName
ATXCONFIGENTRY	INI_INT_PROC		, section_tpafiles		, key_tplvldisable	, FALSE 			, LVLAltTPAsDisable

ATXCONFIGENTRY	INI_INT_PROC		, section_pathtracing		, key_ptpathtraceon	, FALSE 			, PTEnabled
ATXCONFIGENTRY	INI_INT_PROC		, section_pathtracing		, key_ptrate		, def_ptinterval		, PTInterval
ATXCONFIGENTRY	INI_INT_PROC		, section_pathtracing		, key_ptmaxpos		, def_ptmaxpos			, PTMaxPos
ATXCONFIGENTRY	INI_INT_PROC		, section_pathtracing		, key_ptsecsperpos	, def_ptmsecsperpos		, PTMSecsDisplayPerPos
ATXCONFIGENTRY	INI_INT_PROC		, section_pathtracing		, key_ptfadedelay	, def_ptfadedelay		, PTFadeDelay
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_pathtracing		, key_ptradius		, def_ptradius			, PTRadius
ATXCONFIGENTRY	INI_HEX_PROC		, section_pathtracing		, key_ptcolor		, def_ptcolor			, PTColor

ATXCONFIGENTRY	INI_INT_PROC		, section_particles		, key_persparticles	, FALSE 			, CPBaseClipFromDispEnabled
ATXCONFIGENTRY	INI_INT_PROC		, section_particles		, key_maxpartcount	, 0				, CPBaseForcedValueOverride

ATXCONFIGENTRY	INI_INT_PROC		, section_raineffect		, key_refeatureon	, FALSE 			, RainFeatureEnabled
ATXCONFIGENTRY	INI_INT_PROC		, section_raineffect		, key_recurrenabled	, FALSE 			, CurrentRainEnabled
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_raineffect		, key_redefradius	, def_redefradius		, (DefaultRainEffect.Area.XPos)
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_raineffect		, key_remaxceiling	, def_remaxceiling		, (DefaultRainEffect.Area.ZPos)
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_raineffect		, key_reminceiling	, def_reminceiling		, (DefaultRainEffect.Area.ZNeg)
ATXCONFIGENTRY	INI_INT_PROC		, section_raineffect		, key_redropinterval	, def_redropinterval		, (DefaultRainEffect.DropGroupInterval)
ATXCONFIGENTRY	INI_INT_PROC		, section_raineffect		, key_redropspergroup	, def_redropspergroup		, (DefaultRainEffect.ParticlesPerDropGroup)
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_raineffect		, key_redefthreshold	, def_redefthreshold		, (DefaultRainEffect.ParticleThreshold)
ATXCONFIGENTRY	INI_FLOAT_PROC		, section_raineffect		, key_redefparam7	, def_redefparam7		, (DefaultRainEffect.ParticleParam7)

INI_ENTRIES_TABLE_END:


; unused entries

;ATXCONFIGENTRY  INI_INT_PROC            , section_general               , key_atxsse            , FALSE                         , UseATXSSEOpts
;ATXCONFIGENTRY  INI_INT_PROC            , section_general               , key_showrates         , FALSE                         , UseShowRefreshRates
;ATXCONFIGENTRY  INI_KEY_PROC            , section_hotkeys               , key_drvq              , ZERO_STRING                   , UseATXDRVEscKey                       ; NOT IMPLEMENTED
;ATXCONFIGENTRY  INI_INT_PROC            , section_troubleshooting       , key_classoutput       , FALSE                         , EnableClassOutputter

;ATXCONFIGENTRY  INI_STR_EXTMAX_PROC     , section_tpafiles              , key_tpaambient        , def_qscurrentfile             , AlternateAmbientTPAFileName           ; the full path is added in MAININIT
;ATXCONFIGENTRY  INI_STR_EXTMAX_PROC     , section_tpafiles              , key_tpaeffects        , def_qscurrentfile             , AlternateEffectsTPAFileName
;ATXCONFIGENTRY  INI_STR_EXTMAX_PROC     , section_tpafiles              , key_tpastream         , def_qscurrentfile             , AlternateStreamTPAFileName