;=====================================================
; PRE-RENDER INTERCEPT MAIN FUNCTION
;=====================================================
; intercepts CAnimations CMessageStep-response method
; (called for *.asa animations, possibly others)

;=====================================================
INTERCEPTPROC PRERENDERINTERCEPT
;=====================================================
; must preserve ecx,esi,edi,ebp,ebx

JUMPIFNOTGAMEWINDOW .nointercept

push ecx
push ebx
push esi
push edi
push ebp

	PLUGINSCBINVOKE PLUGIN_CALLBACKS.PreScreenRender

	BBMCALL DoFollowDinoRTMain,[FDEnabled]
	BBMCALL DoTHIRDPCheatRTMain,[THIRDPEnabled]
	BBMCALL DoRayCastAimdotUpdate,[THIRDPAIMEnabled]
	BBMCALL RainEffectGenerationRT,[CurrentRainEnabled]

pop ebp
pop edi
pop esi
pop ebx
pop ecx

.nointercept:
jmp [CAnimationsCMessageStepMethod]		; transfer control back to true method



