;============================================================
ATXPROC RANDOMIZE_RANDOM_PROC
;============================================================

	invoke time,0
	invoke srand,eax

add esp,8
ret

;============================================================
ATXPROC GetRandomNumber 		; [esp+4] = below or equal to this number and not zero
;============================================================

	invoke rand
	mov ecx,[esp+4]
	xor edx,edx
	test ecx,ecx
	     jz .dividebyzero

	div ecx
	mov eax,edx			; remainder
	add eax,1

ret 4					; returns number in eax (0 if param was null)

.dividebyzero:

	xor eax,eax

ret 4

;============================================================
proc GetRandomFloatInInterval lpResult, MinFloat, MaxFloat
;============================================================
; maximum divisions = 256

local RanNumIntLtd:DWORD

	invoke rand

	and eax,0FFh
	mov edx,[lpResult]
	mov [RanNumIntLtd],eax
	fld [MinFloat]
	fld [MaxFloat]
	fsub st0,st1			; MaxFloat-MinFloat
	fimul DWORD [RanNumIntLtd]
	fmul [float_1div255]		; (MaxFloat-MinFloat) * (random number <= 255)/255
	faddp st1,st0			; add to MinFloat
	fstp DWORD [edx]

ret
endp
