;===================================================================
MACRO COMPSTR string1,string2 {
;===================================================================

	lea ecx,string1
	lea edx,string2
	call CompareStrings

      }

;===================================================================
MACRO FINDSTRINGSTART reg1 {		; scans for string start amidst space/tab characters
;===================================================================
local .scanloop,.scanloopend

	dec reg1
	.scanloop:
	inc reg1
	cmp BYTE [reg1],09h		; tab
	    jz .scanloop
	cmp BYTE [reg1],20h		; space
	    jz .scanloop
	.scanloopend:

      }

;===================================================================
MACRO FINDSTRINGEND reg1 {
;===================================================================
local .scanloop,.endfound

	cmp BYTE [reg1],0
	  jz .endfound
	.scanloop:
	inc reg1
	cmp BYTE [reg1],0
	    jnz .scanloop
	.endfound:

      }

;===================================================================
MACRO CHAR_TOLOWERCASE reg {
;===================================================================

	cmp reg,5Ah
	    ja @f
	cmp reg,41h
	    jb @f
	add reg,20h
	@@:

      }

;===================================================================
MACRO CHAR_TOUPPERCASE reg {
;===================================================================

	cmp reg,61h
	    jb @f
	cmp reg,7Ah
	    ja @f
	sub reg,20h
	@@:

      }

;===================================================================
macro SCANFOR string1 {
;===================================================================
local .ScanForLoop

	.ScanForLoop:
	inc edi
	cmp edi,ebx
	    jnb NEW_BITMAP_LOAD_FAIL
	cmp DWORD [edi],string1
	    jnz .ScanForLoop
	add edi,4
	cmp edi,ebx
	    jnb NEW_BITMAP_LOAD_FAIL

      }

;===================================================================
MACRO MOVESTRING dest,source,length {
;===================================================================

	mov ecx,length
	push esi
	push edi
	mov esi,source
	lea edi,dest
	rep movsb	     ;move string to allocated memory
	pop edi
	pop esi

      }

