;============================================================
MACRO ATXUIDLGKEYDISPATCH keycode,flagval,methodoffset {
;============================================================
; input: edx = virtual key code
;        ecx = CUIDlg instance
;        eax = 1 if key down, 0 if key up

	local .notthiskey,.keydown,.keynotyetdown

	cmp edx,keycode
	jnz .notthiskey

	mov eax,[esp+8]
	test eax,eax
	jnz .keydown

		test [ecx+CUIDlg.EnabledKeys],flagval
		jz .keynotyetdown

			mov eax,[ecx]
			call [eax+methodoffset]

		.keynotyetdown:
		ret 10h

	.keydown:

		; test for autorepeat (want to ignore autorepeat)
		mov eax,[esp+16]
		test eax,KF_REPEAT
		jnz .keynotyetdown

			or [ecx+CUIDlg.EnabledKeys],flagval
			ret 10h

	.notthiskey:

      }
