;============================================================
ATXPROC DisplayFPS
;============================================================
; displays FPS (.5 second interval)

	GETDDSURFACEDC

	invoke GetTickCount
	mov ecx,eax
	sub eax,[FPSLastFrameTime]
	cmp eax,500
	    jb .noupdatefps

	push eax
	mov [FPSLastFrameTime],ecx
	fild [FPSFrameCount]
	fild DWORD [esp]
	fdivp st1,st0
	and [FPSFrameCount],0
	fmul [float_1000]
	add esp,4
	fstp QWORD [FPSLastRate]

	.noupdatefps:

	inc [FPSFrameCount]

	mov ebx,stack_ext_buffer
	cinvoke sprintf,ebx,FPS_DISPLAY_STR,DWORD [FPSLastRate],DWORD [FPSLastRate+4]

	invoke TextOut,edi,0,FPS_MSG,ebx,eax

	RELEASEDDSURFACEDC

ret