;=====================================================
ATXPROC SetNewTimeStamp
;=====================================================
; COUNTER FUNCTIONS

	cmp [CounterFirstRun],1
	    jz .firstrun
	cmp [UseTimeCounter],1
	    jz SHOW_COUNTER
	ret

	.firstrun:

	mov [CounterFirstRun],0
	invoke GetTickCount
	mov [FirstTimeStamp],eax

	cmp [UseTimeCounter],1
	    jz SHOW_COUNTER
	ret

;===================================================
ATXPROC SHOW_COUNTER
;===================================================
; [ebp-4]        = hours
; [ebp-8]        = minutes
; [ebp-12]       = seconds
; ADDR [ebp-100] = buffer for time stamp string (result)

push ebp
mov ebp,esp
sub esp,12

	GETDDSURFACEDC

	invoke GetTickCount
	sub eax,[FirstTimeStamp]
	mov ebx,eax

	cdq
	mov ecx,MILLISECONDS_PER_HOUR
	div ecx 				; get # hours passed
	mov [ebp-4],eax

	mov eax,edx				; remainder=milliseconds left
	cdq
	mov ecx,MILLISECONDS_PER_MINUTE
	div ecx
	mov [ebp-8],eax

	mov eax,edx				; remainder=milliseconds left
	cdq
	mov ecx,MILLISECONDS_PER_SECOND
	div ecx
	mov [ebp-12],eax

	mov ebx,stack_ext_buffer
	cinvoke wsprintf,ebx,TIME_DISPLAY_STR,[ebp-4],[ebp-8],[ebp-12]
	invoke TextOut,edi,0,TIME_STAMP_MSG,ebx,eax

	RELEASEDDSURFACEDC

mov esp,ebp
pop ebp
ret