;============================================================
INTERCEPTPROC DINO_VOCAL_PROC_NEW		; [esp+4] = Dinosaur, [esp+8] = Vocal, ecx = base instance
;============================================================
; the original proc (included) calculates:
; eax = base + 388h + 120*(Vocal+14*Dinosaur)
; -> 120 bytes per Vocal, 120*14 bytes per Dinosaur (value)

	mov eax,[esp+4]
	add ecx,388h
	cmp eax,7
	    jb .uselowdinosaurvalues
	    sub eax,7
	    cmp eax,[UseNewDinoVocals]
	    mov ecx,[NewDinoVocalsBuffer]
		jnb .dinosaurvaluetoohigh
	.uselowdinosaurvalues:

	lea edx,[eax*8]
	sub edx,eax
	mov eax,[esp+8]
	cmp eax,13
	    ja .vocalvaluetoohigh
	lea eax,[eax+2*edx]
	lea eax,[eax+2*eax]
	lea edx,[eax+4*eax]
	lea eax,[ecx+8*edx]

ret 8

.dinosaurvaluetoohigh:

	add eax,7
	stdcall WriteATXInGameError,DINOVOCALS_ERROR_1,eax
	mov DWORD [0],eax

ret 8

.vocalvaluetoohigh:
; will cause crash ("smoothly", and handled, instead of accessing random
; higher memory, as is done by the game by default)

	stdcall WriteATXInGameError,DINOVOCALS_ERROR_2,eax
	mov DWORD [0],eax						; crash!

ret 8

