;=======================================================
#label GetFileNameInPath()_1 = 0x005E9890
;=======================================================

char* GetFileNameInPath(
 char *filePath;
);

 Returns a pointer to the filename part of the given file's path;
 points into the same string.


;=======================================================
; class CStringDesc (unofficial)
;=======================================================

typedef struct CStringDesc {
    INT Size;                    // without null-terminator
    DWORD Flags;                 // if 10h or below, string fits in ShortName
    STRING ShortName[16];        // used if string is 15 bytes or less
    LPSTRING lpString;
}

#label CStringDesc::FreeStringPtr()_0 = 0x004907D0
#label CStringDesc::GetOffsetString()_1 = 0x00490BC0
#label CStringDesc::ResetString()_1 = 0x00490630

VOID CStringDesc::FreeStringPtr(
);

Frees string memory if allocated, but NOT instance memory.

LPSTRING CStringDesc::GetOffsetString(
 DWORD StringOffset
);

Returns CStringDesc.lpString with an added offset of StringOffset.
If StringOffset is greater than CStringDesc.Size, returns null.
Usually, StringOffset is null.

CStringDesc CStringDesc::ResetString(
 LPSTRING lpString    // can point to an empty string
);

* Not sure what this does. Seems to replace string with
new one, freeing old string. Often, lpString points
to an empty string, so old is freed and no new string
is added. String pointer is not nulled out if this is
the case. I think string pointer is valid only if CStringDesc.Size>0.


